## libxisf 0.2.8

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14)

project(libXISF VERSION 0.2.8 LANGUAGES CXX C
    HOMEPAGE_URL https://gitea.nouspiro.space/nou/libXISF
    DESCRIPTION "LibXISF is C++ library that can read and write XISF files produced by PixInsight.")

include(CMakeDependentOption)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_C_VISIBILITY_PRESET hidden)
set(CMAKE_CXX_VISIBILITY_PRESET hidden)

option(BUILD_SHARED_LIBS "Build using shared libraries" ON)
option(USE_BUNDLED_LIBS "Use bundled LZ4 PugiXML and Zlib. You can still exclude some" ON)
cmake_dependent_option(USE_BUNDLED_LZ4 "Use bundled LZ4" ON "USE_BUNDLED_LIBS" OFF)
cmake_dependent_option(USE_BUNDLED_PUGIXML "Use bundled PugiXML" ON "USE_BUNDLED_LIBS" OFF)
cmake_dependent_option(USE_BUNDLED_ZLIB "Use bundled Zlib" ON "USE_BUNDLED_LIBS" OFF)

find_package(PkgConfig)

if(USE_BUNDLED_LZ4)
    list(APPEND THIRD_PARTY_SRC
        lz4/lz4.c
        lz4/lz4.h
        lz4/lz4hc.c
        lz4/lz4hc.h)
    list(APPEND THIRD_PARTY_INCLUDE lz4)
else(USE_BUNDLED_LZ4)
    pkg_check_modules(LZ4 liblz4 IMPORTED_TARGET REQUIRED)
endif(USE_BUNDLED_LZ4)
if(USE_BUNDLED_PUGIXML)
    list(APPEND THIRD_PARTY_SRC pugixml/pugixml.cpp)
    list(APPEND THIRD_PARTY_INCLUDE pugixml)
else(USE_BUNDLED_PUGIXML)
    pkg_check_modules(PUGIXML pugixml IMPORTED_TARGET REQUIRED)
endif(USE_BUNDLED_PUGIXML)
if(USE_BUNDLED_ZLIB)
    list(APPEND THIRD_PARTY_SRC
        zlib/adler32.c
        zlib/compress.c
        zlib/crc32.c
        zlib/deflate.c
        zlib/gzclose.c
        zlib/gzlib.c
        zlib/gzread.c
        zlib/gzwrite.c
        zlib/inflate.c
        zlib/infback.c
        zlib/inftrees.c
        zlib/inffast.c
        zlib/trees.c
        zlib/uncompr.c
        zlib/zutil.c)
    set(ZLIB_PC ${CMAKE_CURRENT_BINARY_DIR}/zlib.pc)
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/zlib/zlib.pc.cmakein ${ZLIB_PC} @ONLY)
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/zlib/zconf.h.cmakein ${CMAKE_CURRENT_BINARY_DIR}/zconf.h @ONLY)
    list(APPEND THIRD_PARTY_INCLUDE zlib)
else(USE_BUNDLED_ZLIB)
    pkg_check_modules(ZLIB zlib IMPORTED_TARGET REQUIRED)
endif(USE_BUNDLED_ZLIB)

add_library(XISF
  bytearray.cpp
  libXISF_global.h
  libxisf.cpp
  libxisf.h
  streambuffer.cpp
  streambuffer.h
  utils.cpp
  variant.cpp
  ${THIRD_PARTY_SRC}
)

if(USE_BUNDLED_LIBS)
    target_include_directories(XISF PRIVATE ${THIRD_PARTY_INCLUDE})
    if(NOT USE_BUNDLED_LZ4)
        target_link_libraries(XISF PUBLIC PkgConfig::LZ4)
        list(APPEND PC_LIBS_REQUIRE lz4)
    endif(NOT USE_BUNDLED_LZ4)
    if(NOT USE_BUNDLED_PUGIXML)
        target_link_libraries(XISF PUBLIC PkgConfig::PUGIXML)
        list(APPEND PC_LIBS_REQUIRE pugixml)
    endif(NOT USE_BUNDLED_PUGIXML)
    if(NOT USE_BUNDLED_ZLIB)
        target_link_libraries(XISF PUBLIC PkgConfig::ZLIB)
        list(APPEND PC_LIBS_REQUIRE zlib)
    endif(NOT USE_BUNDLED_ZLIB)
else(USE_BUNDLED_LIBS)
    target_link_libraries(XISF PUBLIC PkgConfig::LZ4 PkgConfig::PUGIXML PkgConfig::ZLIB)
    list(APPEND PC_LIBS_REQUIRE lz4 pugixml zlib)
endif(USE_BUNDLED_LIBS)

set_target_properties(XISF PROPERTIES VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR})

if(BUILD_SHARED_LIBS)
    target_compile_definitions(XISF PRIVATE LIBXISF_LIBRARY)
else(BUILD_SHARED_LIBS)
    target_compile_definitions(XISF PUBLIC LIBXISF_STATIC_LIB)
endif(BUILD_SHARED_LIBS)

set(XISF_PUBLIC_HEADERS libxisf.h libXISF_global.h)

include(GNUInstallDirs)

install(FILES ${XISF_PUBLIC_HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libxisf.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
install(TARGETS XISF LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})

list(JOIN PC_LIBS_REQUIRE ", " PC_REQUIRE_STR2)
if(NOT PC_REQUIRE_STR2 STREQUAL "")
    string(REPLACE "lz4" "liblz4" PC_REQUIRE_STR ${PC_REQUIRE_STR2})
endif()
list(TRANSFORM PC_LIBS_REQUIRE PREPEND "-l")
list(JOIN PC_LIBS_REQUIRE " " PC_LIBS_STR)
configure_file(libxisf.pc.in libxisf.pc @ONLY)

#testing

enable_testing()

add_executable(LibXISFTest
    test/main.cpp
    test/benchmark.cpp)

target_link_libraries(LibXISFTest XISF)

add_test(NAME LibXISFTest        COMMAND LibXISFTest)
add_test(NAME LibXISFTestRead    COMMAND LibXISFTest "${CMAKE_CURRENT_LIST_DIR}/test/test.xisf")
add_test(NAME LibXISFTestReadLZ4 COMMAND LibXISFTest "${CMAKE_CURRENT_LIST_DIR}/test/test_lz4.xisf")

=== debian/changelog ===
libxisf (0.2.8-1) unstable; urgency=medium

  * Release 0.2.8
 -- Dušan Poizl <nou@nouspiro.space>  Tue, 13 Jun 2023 12:29:10 +0200

libxisf (0.2.7-1) unstable; urgency=medium

  * Add option to exclude each bundled lib
  * Fix error with USE_BUNDLED_LIBS
  * Fix issue with ColorFilterArray
  * Make pkg-config optional
  * Add generation of pkgconfig file
  * Add support for thumbnail
  * Add StreamBuffer to optimize save/load from memory
  * Add method to for ICC profile
  * Fix generating pkgconfig file
  * Fix "string sub-command REPLACE requires at least four arguments"
  * Fix reading ICCprofile
  * Add pcfiles to install

 -- Dušan Poizl <nou@nouspiro.space>  Mon, 12 Jun 2023 16:52:02 +0200

libxisf (0.2.1-1) unstable; urgency=medium

  * Initial release

 -- Dušan Poizl <nou@nouspiro.space>  Fri, 17 Mar 2023 19:59:53 +0100

=== debian/control ===
Source: libxisf
Priority: optional
Maintainer: Dušan Poizl <nou@nouspiro.space>
Build-Depends: debhelper-compat (= 13),
               cmake,
               pkg-config,
               liblz4-dev,
               libpugixml-dev,
               zlib1g-dev
Standards-Version: 4.6.2
Section: libs
Homepage: https://nouspiro.space/?page_id=306
Vcs-Git: https://salsa.debian.org/debian-astro-team/libxisf.git
Vcs-Browser: https://salsa.debian.org/debian-astro-team/libxisf

Package: libxisf-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libxisf0 (= ${binary:Version}), ${misc:Depends}
Description: Library to load and save XISF images development files
 This package contain development files.
 .
 XISF is native format of PixInsight astroprocessing suite.
 Extensible Image Serialization Format (XISF) is the native file format
 of PixInsight. It is a free, open format for storage, management and
 interchange of digital images and associated data.
 .
 This C++ library implements XISF specification 1.0 which can be found at
 https://pixinsight.com/doc/docs/XISF-1.0-spec/XISF-1.0-spec.html

Package: libxisf0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Library to load and save XISF images
 XISF is native format of PixInsight astroprocessing suite.
 Extensible Image Serialization Format (XISF) is the native file format
 of PixInsight. It is a free, open format for storage, management and
 interchange of digital images and associated data.
 .
 This C++ library implements XISF specification 1.0 which can be found at
 https://pixinsight.com/doc/docs/XISF-1.0-spec/XISF-1.0-spec.html

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_LIBRARY_ARCHITECTURE="$(DEB_HOST_MULTIARCH)" -DUSE_BUNDLED_LIBS=Off

## libxisf 0.2.13

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.14)
 
-project(libXISF VERSION 0.2.8 LANGUAGES CXX C
+project(libXISF VERSION 0.2.13 LANGUAGES CXX C
     HOMEPAGE_URL https://gitea.nouspiro.space/nou/libXISF
     DESCRIPTION "LibXISF is C++ library that can read and write XISF files produced by PixInsight.")
 
@@ -94,6 +94,12 @@
 
 set_target_properties(XISF PROPERTIES VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR})
 
+pkg_check_modules(ZSTD libzstd IMPORTED_TARGET)
+if(ZSTD_FOUND)
+    target_compile_definitions(XISF PRIVATE HAVE_ZSTD)
+    target_link_libraries(XISF PUBLIC PkgConfig::ZSTD)
+endif(ZSTD_FOUND)
+
 if(BUILD_SHARED_LIBS)
     target_compile_definitions(XISF PRIVATE LIBXISF_LIBRARY)
 else(BUILD_SHARED_LIBS)

=== debian/changelog ===
libxisf (0.2.13-1~mx23+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Fri, 25 Apr 2025 01:22:17 -0700

libxisf (0.2.13-1) unstable; urgency=medium

  * Add new XISFModify class to edit FITSKeywords
  * Release 0.2.13

 -- Dušan Poizl <nou@nouspiro.space>  Sat, 25 Jan 2025 16:03:21 +0100

libxisf (0.2.12-1) unstable; urgency=medium

  * Fix bug in writing ICCProfile
  * Fix handling big +2GiB images
  * Release 0.2.12

 -- Dušan Poizl <nou@nouspiro.space>  Sat, 23 Mar 2024 09:40:45 +0100

libxisf (0.2.10-1) unstable; urgency=medium

  * Fix writing incorrect header size

 -- Dušan Poizl <nou@nouspiro.space>  Mon, 16 Oct 2023 22:17:20 +0200

libxisf (0.2.9-1) unstable; urgency=medium

  * Add support for ZSTD compression

 -- Dušan Poizl <nou@nouspiro.space>  Sun, 13 Aug 2023 23:44:56 +0200

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,15 @@
 Source: libxisf
 Priority: optional
-Maintainer: Dušan Poizl <nou@nouspiro.space>
-Build-Depends: debhelper-compat (= 13),
-               cmake,
-               pkg-config,
+Maintainer: Steven Pusser <stevep@mxlinux.org>
+XSBC-Original-Maintainer: Dušan Poizl <nou@nouspiro.space>
+Build-Depends: cmake,
+               debhelper-compat (= 13),
                liblz4-dev,
                libpugixml-dev,
+               libzstd-dev,
+               pkgconf,
                zlib1g-dev
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Section: libs
 Homepage: https://nouspiro.space/?page_id=306
 Vcs-Git: https://salsa.debian.org/debian-astro-team/libxisf.git
@@ -21,7 +23,7 @@
 Description: Library to load and save XISF images development files
  This package contain development files.
  .
- XISF is native format of PixInsight astroprocessing suite.
+ XISF is the native format of PixInsight astroprocessing suite.
  Extensible Image Serialization Format (XISF) is the native file format
  of PixInsight. It is a free, open format for storage, management and
  interchange of digital images and associated data.
@@ -32,9 +34,9 @@
 Package: libxisf0
 Architecture: any
 Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: Library to load and save XISF images
- XISF is native format of PixInsight astroprocessing suite.
+ XISF is the native format of PixInsight astroprocessing suite.
  Extensible Image Serialization Format (XISF) is the native file format
  of PixInsight. It is a free, open format for storage, management and
  interchange of digital images and associated data.

=== debian/rules ===
--- 
+++ 
@@ -14,3 +14,8 @@
 
 override_dh_auto_configure:
 	dh_auto_configure -- -DCMAKE_LIBRARY_ARCHITECTURE="$(DEB_HOST_MULTIARCH)" -DUSE_BUNDLED_LIBS=Off
+
+# No dbgsym packages:
+override_dh_strip:
+	@echo "NO--THANKS ANYWAY--but not building dbgsym packages for MX Linux"
+	dh_strip --no-automatic-dbgsym
